%evaluate the test statistic
function [est,f] = test_stat(Y,X,y_0,weig_g,algorithm)
global exitflag
if algorithm == 1  
    options=optimset('Display',     'off',...
        'Algorithm', 'trust-region-reflective',...
        'TolFun',1e-10,...
        'TolX',       1e-10,...
        'MaxIter',     1000,...
        'MaxFunEvals', 100000000);
else
    options=optimset('Display',     'off',...
        'Algorithm', 'levenberg-marquardt',...
        'TolFun',1e-10,...
        'TolX',       1e-10,...
        'MaxIter',     1000,...
        'MaxFunEvals', 100000000);
end

[est,f,~,exitflag,~] = lsqnonlin(@(y)(1e5*(min(Y-X*[y zeros(size(y));...
    zeros(size(y)) y],zeros(size(Y)))).*(kron(ones(1,2),weig_g.^0.5))),y_0,[],[],options);
