function f = obj_bound(sigma,rc_seed,x,expmvalbound,share_lap,mk_id,mk_ind,M,m,ns,iota_u,iota_l,g,weig_g)
global theta_bound lin_param
rc_sd = sigma*rc_seed;
mu_x = bsxfun(@times,rc_sd,x);
x_ind_exp = exp(mu_x);

delta_lap = meanval(expmvalbound,share_lap,x_ind_exp,mk_id,mk_ind,M);
delta_u = delta_lap - log(share_lap) + log((m+iota_u)./ns);
delta_l = delta_lap - log(share_lap) + log((m+iota_l)./ns);

y_u = delta_u;
y_l = -delta_l;
X = [ones(size(x)) x];
Y_sum = g'*[y_l y_u];
X_sum = g'*[-X X];


[theta_bound,f] = test_stat((1/(M^0.5))*Y_sum,(1/(M^0.5))*X_sum,lin_param,weig_g);
