function [f, delta] = obj_blp(rc_para,price,delta_fix,expmval,rc_seed,IV,invA,share,mkid,mkind)

rc = exp(norminv(rc_seed,rc_para(1),rc_para(2))); 
rc_price = -bsxfun(@times,rc,price);
rc_price_exp = exp(rc_price);

delta = meanval(expmval,share,rc_price_exp,mkid,mkind);

resid = delta - delta_fix;
temp = resid'*IV;
f = temp*invA*temp';

