function f = obj_bound(rc_para,rc_seed,price,delta_fix,expmval0,share_lap,mkid,mkind,iota_u,iota_l,m,ns,g,weig_g)

rc = exp(norminv(rc_seed,rc_para(1),rc_para(2))); 
rc_price = -bsxfun(@times,rc,price);
rc_price_exp = exp(rc_price);

delta_lap = meanval(expmval0,share_lap,rc_price_exp,mkid,mkind);
delta_u = delta_lap - log(share_lap) + log((m+iota_u)./ns);
delta_l = delta_lap - log(share_lap) + log((m+iota_l)./ns);

y_u = delta_u;
y_l = -delta_l;
Y_sum = g'*[y_l y_u];
X_sum = g'*[-delta_fix delta_fix];

f_tmp = (min(Y_sum-X_sum,zeros(size(Y_sum)))).*(kron(ones(1,2),weig_g.^0.5));

f = sum((f_tmp(:)).^2);